#property copyright "Dmitry Yakovlev, Russia,Omsk WM R865705290089"
#property link      "http://fehu.b13.su/  dmitryyakv@yandex.ru  ICQ: 11-065-106"

#property indicator_chart_window
#property indicator_buffers 6

//---- input parameters
extern string _t1=" 1";
extern int TF1=15;
extern int K1=5;
extern int D1=3;
extern int S1=3;
extern int Price1=0;
extern color cColor1=RoyalBlue;

extern string _t2=" 2";
extern int TF2=30;
extern int K2=5;
extern int D2=3;
extern int S2=3;
extern int Price2=0;
extern color cColor2=Red;

extern string _t3=" 3";
extern int TF3=60;
extern int K3=5;
extern int D3=3;
extern int S3=3;
extern int Price3=0;
extern color cColor3=Blue;

extern string _ma="  50%";
extern int MA=50;
extern string _sc=", 0-";
extern double GraphScale=0;
extern string _lv=" 20%,50%,80%, 0-";
extern int ShowLevels=1;
/*extern */string _ex=", 0-";
/*extern */int ShowExtremums=1;
/*extern */int ArrowCode=108;
/*extern */int ExtremSize=1;

double Scale;
//---- buffers
double Signal1[];
double Signal2[];
double Signal3[];
double Buffer1[];
double Buffer0[];
double Buffer5[];
double Stoch1[];
double Stoch2[];
double Stoch3[];
//----
int draw_begin1=0;
int draw_begin2=0;

int lblcnt=15;
int init()
{
   int i;
   string short_name;
   
   string tmp;
   /*for(int k=0;k<lblcnt;k++)
   {
      tmp="myStochSignal"+TF+"_"+K+"_"+k;
      ObjectDelete(tmp);
   }*/

   IndicatorBuffers(6);

   SetIndexStyle(0,DRAW_LINE,EMPTY,2,cColor1);
   SetIndexBuffer(0, Signal1);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2,cColor2);
   SetIndexBuffer(1, Signal2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2,cColor3);
   SetIndexBuffer(2, Signal3);
   
   SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,cColor1);
   SetIndexBuffer(3, Buffer1);
   SetIndexStyle(4,DRAW_LINE,EMPTY,EMPTY,cColor1);
   SetIndexBuffer(4, Buffer5);
   SetIndexStyle(5,DRAW_LINE,EMPTY,EMPTY,cColor1);
   SetIndexBuffer(5, Buffer0);

   if(ShowLevels==0)
      for(i=3;i<=5;i++) SetIndexStyle(i,DRAW_NONE);
   
   for(i=6;i<=7;i++) SetIndexStyle(i,DRAW_NONE);
   
//---- name for DataWindow and indicator subwindow label
   short_name="Sto TF="+TF1+" ("+K1+","+D1+","+S1+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Sto TF="+TF1+" ("+K1+","+D1+","+S1+")");
   SetIndexLabel(1,"Sto TF="+TF2+" ("+K2+","+D2+","+S2+")");
   SetIndexLabel(2,"Sto TF="+TF3+" ("+K3+","+D3+","+S3+")");
   SetIndexLabel(3,"80%");
   SetIndexLabel(4,"50%");
   SetIndexLabel(5,"20%");
//----
   draw_begin1=K1+S1;
   draw_begin2=draw_begin1+D1;
   SetIndexDrawBegin(0,draw_begin1);
   SetIndexDrawBegin(1,draw_begin1);
   SetIndexDrawBegin(2,draw_begin1);
   SetIndexDrawBegin(3,draw_begin1);
   SetIndexDrawBegin(4,draw_begin1);
   SetIndexDrawBegin(5,draw_begin1);
//----
   ArraySetAsSeries(Stoch1,true);
   ArraySetAsSeries(Stoch2,true);
   ArraySetAsSeries(Stoch3,true);
   return(0);
  }

void deinit()
{
   string tmp;
   /*for(int k=0;k<lblcnt;k++)
   {
      tmp="myStochSignal"+TF+"_"+K+"_"+k;
      ObjectDelete(tmp);
   }*/
}
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double price;
   double k1=TF1/Period();
   double k2=TF2/Period();
   double k3=TF3/Period();
//----
   if(Bars<=draw_begin2) return(0);
   if(ArraySize(Stoch1)!=Bars) ArrayResize(Stoch1,Bars);
   if(ArraySize(Stoch2)!=Bars) ArrayResize(Stoch2,Bars);
   if(ArraySize(Stoch3)!=Bars) ArrayResize(Stoch3,Bars);
   //---- initial zero
   if(counted_bars<1)
      for(i=1;i<=draw_begin2;i++)
      {
         Signal1[Bars-i]=0;
         Signal2[Bars-i]=0;
         Signal3[Bars-i]=0;
         Buffer0[Bars-i]=0;
         Buffer1[Bars-i]=0;
         Buffer5[Bars-i]=0;
         Stoch1[Bars-i]=0;
         Stoch2[Bars-i]=0;
         Stoch3[Bars-i]=0;
      }
   
   Scale=GraphScale;
   if(GraphScale==0)
      Scale=(iMA(Symbol(),PERIOD_D1,5,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol(),PERIOD_D1,5,0,MODE_SMA,PRICE_LOW,0))/Point;

   double kk=Point*Scale/100;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
   {
      Stoch1[i]=iStochastic(Symbol(),0,K1*k1,D1*k1,S1,MODE_EMA,Price1,MODE_SIGNAL,i);
      Signal1[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i)+(Stoch1[i]-50)*kk;
      
      Stoch2[i]=iStochastic(Symbol(),0,K2*k2,D2*k2,S2,MODE_EMA,Price2,MODE_SIGNAL,i);
      Signal2[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i)+(Stoch2[i]-50)*kk;
      
      Stoch3[i]=iStochastic(Symbol(),0,K3*k3,D3*k3,S3,MODE_EMA,Price3,MODE_SIGNAL,i);
      Signal3[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i)+(Stoch3[i]-50)*kk;

      if(ShowLevels==1)
      {
         Buffer1[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i)+30*kk;
         Buffer5[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i);
         Buffer0[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i)-30*kk;
      }
   }
   
   return(0);
}

